<template>
    <div ref="scrollContainer" class="scroll-container">
      <!-- Pull to refresh -->
      <PullToRefresh ref="pullRefresh" :container="scrollContainer" @refresh="fetchData"></PullToRefresh>
      
      <!-- Page content -->
      <div class="container mx-auto p-8 mb-12">
        <!-- Page title -->
        <PageTitle title="Advices" />

        <Alert v-if="showError" type="error" title="Error" :body="errorText" />

        <!-- List of Advices -->
        <div>
            <div v-for="item in list" :key="item.id" class="flex flex-col w-full indicator">
                <span v-if="isNewAdvice(item)" class="indicator-item badge badge-success" style="z-index: 0;">new</span>
                <div class="p-10 grid card bg-neutral rounded-box place-items-center" style="z-index: -1;">
                <span class="material-symbols-outlined mb-5">
                    eco
                </span>
                <!-- Use dynamic content based on item properties -->
                    {{ item.message }}
                </div>
                <div class="divider"></div>
            </div>
        </div>
        
        <!-- Loading -->
        <div v-if="loading">
          <div class="skeleton h-32 w-full flex flex-col justify-center">
            <button class="">
              <span class="loading loading-spinner"></span>
              Loading Advices...
            </button>
          </div>
        </div>

      </div>

    </div>
  </template>
  
<script>
  import GenericWidget from '@/components/GenericWidget.vue';
  import PullToRefresh from '@/components/PullToRefresh.vue';
  import PageTitle from '@/components/PageTitle.vue';
  import FloatingActionButton from '@/components/FloatingActionButton.vue';
  import Modal from '@/components/Modal.vue';
  import Alert from '@/components/Alert.vue';

  import ROOMS from '@/assets/rooms.json';
  import ICONS from '@/assets/icons.json';
  
  export default {
    components: {
      GenericWidget,
      PullToRefresh,
      PageTitle,
      FloatingActionButton,
      Modal,
      Alert
    },
    data() {
      return {
        list: [],
        scrollContainer: {},
        showError: false,
        loading: false
      };
    },
    mounted() {
        // prepare the pull-to-refresh
        this.scrollContainer = this.$refs.scrollContainer
        this.$refs.pullRefresh.init()
        
        // fetch the data for the first time
        this.fetchData();
    },
    methods: {
        fetchData() {
            // Fetching the list of routines
            var self = this;
            self.loading = true;
            self.$axios.get('/advices', {})
            .then(function (response) {
                // handle success
                self.showError = false
                self.list = response.data;
            })
            .catch(function (error) {
                // handle error
                self.showError = true;
                self.errorText = error.response.data.message;
            })
            .finally(function () {
                // always executed
                self.loading = false;
            });

            setTimeout(() => {
                this.$refs.pullRefresh.refreshSuccess()
            }, 1000)
        },
        isNewAdvice(advice) {
            // Assuming you want to mark advices received in the last 24 hours as new
            const twentyFourHoursAgo = new Date(Date.now() - 24 * 60 * 60 * 1000);
            const adviceTimestamp = new Date(advice.timestamp);
            return adviceTimestamp > twentyFourHoursAgo;
        },
    }
  }
</script>
  